Merge "Add intel_iommu to kernel cmdline"
[icn.git] / deploy / metal3 / scripts / 01_metal3.sh
1 #!/usr/bin/env bash
2 set -eu -o pipefail
3
4 LIBDIR="$(dirname "$(dirname "$(dirname "$PWD")")")"
5
6 eval "$(go env)"
7
8 source $LIBDIR/env/lib/common.sh
9
10 if [[ $EUID -ne 0 ]]; then
11     echo "This script must be run as root"
12     exit 1
13 fi
14
15 IMAGE_URL=http://172.22.0.1/images/${BM_IMAGE}
16 IMAGE_CHECKSUM=http://172.22.0.1/images/${BM_IMAGE}.md5sum
17
18 function clone_repos {
19     mkdir -p "${M3PATH}"
20     if [[ -d ${BMOPATH} && "${FORCE_REPO_UPDATE}" == "true" ]]; then
21       rm -rf "${BMOPATH}"
22     fi
23     if [ ! -d "${BMOPATH}" ] ; then
24         pushd "${M3PATH}"
25         git clone "${BMOREPO}"
26         popd
27     fi
28     pushd "${BMOPATH}"
29     git checkout "${BMOBRANCH}"
30     git pull -r || true
31     popd
32 }
33
34 function get_default_interface_ipaddress {
35     local _ip=$1
36     local _default_interface=$(awk '$2 == 00000000 { print $1 }' /proc/net/route)
37     local _ipv4address=$(ip addr show dev $_default_interface | awk '$1 == "inet" { sub("/.*", "", $2); print $2 }')
38     eval $_ip="'$_ipv4address'"
39 }
40
41 function create_ssh_key {
42     #ssh key for compute node to communicate back to bootstrap server
43     mkdir -p $BUILD_DIR/ssh_key
44     ssh-keygen -C "compute.icn.akraino.lfedge.org" -f $BUILD_DIR/ssh_key/id_rsa
45     cat $BUILD_DIR/ssh_key/id_rsa.pub >> $HOME/.ssh/authorized_keys
46 }
47
48 function set_compute_key {
49     _SSH_LOCAL_KEY=$(cat $BUILD_DIR/ssh_key/id_rsa)
50     cat << EOF
51 write_files:
52 - path: /opt/ssh_id_rsa
53     owner: root:root
54     permissions: '0600'
55     content: |
56     $_SSH_LOCAL_KEY
57 EOF
58 }
59
60 function deprovision_compute_node {
61     name="$1"
62     if kubectl get baremetalhost $name -n metal3 &>/dev/null; then
63         kubectl patch baremetalhost $name -n metal3 --type merge \
64         -p '{"spec":{"image":{"url":"","checksum":""}}}'
65     fi
66 }
67
68 function set_compute_ssh_config {
69     get_default_interface_ipaddress default_addr
70     cat << EOF
71 - path: /root/.ssh/config
72     owner: root:root
73     permissions: '0600'
74     content: |
75     Host bootstrapmachine $default_addr
76     HostName $default_addr
77     IdentityFile /opt/ssh_id_rsa
78     User $USER
79 - path: /etc/apt/sources.list
80     owner: root:root
81     permissions: '0665'
82     content: |
83     deb [trusted=yes] ssh://$USER@$default_addr:$LOCAL_APT_REPO ./
84 EOF
85 }
86
87 # documentation for the values below may be found at
88 # https://cloudinit.readthedocs.io/en/latest/topics/modules.html
89 function create_userdata {
90     name="$1"
91     username="$2"
92     password="$3"
93     COMPUTE_NODE_FQDN="$name.akraino.icn.org"
94
95     # validate that the user isn't expecting the deprecated
96     # COMPUTE_NODE_PASSWORD to be used
97     if [ "$password" != "${COMPUTE_NODE_PASSWORD:-$password}" ]; then
98         cat <<EOF
99 COMPUTE_NODE_PASSWORD "$COMPUTE_NODE_PASSWORD" not equal to nodes.json $name password "$password".
100 Unset COMPUTE_NODE_PASSWORD and retry.
101 EOF
102         exit 1
103     fi
104
105     printf "#cloud-config\n" >  $name-userdata.yaml
106     if [ -n "$password" ]; then
107         if [ -n "$username" ]; then
108             passwd=$(mkpasswd --method=SHA-512 --rounds 4096 "$password")
109             printf "users:" >>  $name-userdata.yaml
110             printf "\n  - name: ""%s" "$username" >>  $name-userdata.yaml
111             printf "\n    lock_passwd: False" >>  $name-userdata.yaml # necessary to allow password login
112             printf "\n    passwd: ""%s" "$passwd" >>  $name-userdata.yaml
113             printf "\n    sudo: \"ALL=(ALL) NOPASSWD:ALL\"" >>  $name-userdata.yaml
114         else
115             printf "password: ""%s" "$password" >>  $name-userdata.yaml
116         fi
117         printf "\nchpasswd: {expire: False}\n" >>  $name-userdata.yaml
118         printf "ssh_pwauth: True\n" >>  $name-userdata.yaml
119     fi
120
121     if [ -n "$COMPUTE_NODE_FQDN" ]; then
122         printf "fqdn: ""%s" "$COMPUTE_NODE_FQDN" >>  $name-userdata.yaml
123         printf "\n" >>  $name-userdata.yaml
124     fi
125     printf "disable_root: false\n" >>  $name-userdata.yaml
126     printf "ssh_authorized_keys:\n  - " >>  $name-userdata.yaml
127
128     if [ ! -f $HOME/.ssh/id_rsa.pub ]; then
129         yes y | ssh-keygen -t rsa -N "" -f $HOME/.ssh/id_rsa
130     fi
131
132     cat $HOME/.ssh/id_rsa.pub >>  $name-userdata.yaml
133     cloud_init_scripts >> $name-userdata.yaml
134     printf "\n" >>  $name-userdata.yaml
135 }
136
137 function launch_baremetal_operator {
138     docker pull $IRONIC_BAREMETAL_IMAGE
139     kubectl apply -f bmo/namespace/namespace.yaml
140     kubectl apply -f bmo/rbac/service_account.yaml -n metal3
141     kubectl apply -f bmo/rbac/role.yaml -n metal3
142     kubectl apply -f bmo/rbac/role_binding.yaml
143     kubectl apply -f bmo/crds/metal3.io_baremetalhosts_crd.yaml
144     kubectl apply -f bmo/operator/no_ironic/operator.yaml -n metal3
145 }
146
147 function remove_baremetal_operator {
148     kubectl delete -f bmo/operator/no_ironic/operator.yaml -n metal3
149     kubectl delete -f bmo/crds/metal3.io_baremetalhosts_crd.yaml
150     kubectl delete -f bmo/rbac/role_binding.yaml
151     kubectl delete -f bmo/rbac/role.yaml -n metal3
152     kubectl delete -f bmo/rbac/service_account.yaml -n metal3
153     kubectl delete -f bmo/namespace/namespace.yaml
154 }
155
156 function cloud_init_scripts {
157     # The "intel_iommu=on iommu=pt" kernel command line is necessary
158     # for QAT support.
159     cat << 'EOF'
160 write_files:
161 - path: /var/lib/cloud/scripts/per-instance/set_kernel_cmdline.sh
162   owner: root:root
163   permissions: '0777'
164   content: |
165     #!/usr/bin/env bash
166     set -eux -o pipefail
167     grub_file=${1:-"/etc/default/grub"}
168     kernel_parameters="intel_iommu=on iommu=pt"
169     sed -i~ "/^GRUB_CMDLINE_LINUX=/{h;s/\(=\".*\)\"/\1 ${kernel_parameters}\"/};\${x;/^$/{s//GRUB_CMDLINE_LINUX=\"${kernel_parameters}\"/;H};x}" "$grub_file"
170     update-grub
171     reboot
172 EOF
173     cat << 'EOF'
174 - path: /var/lib/cloud/scripts/per-boot/run_dhclient.sh
175   owner: root:root
176   permissions: '0777'
177   content: |
178     #!/usr/bin/env bash
179     set -xe
180     for intf in /sys/class/net/*; do
181         sudo ifconfig `basename $intf` up
182         sudo dhclient -nw `basename $intf`
183     done
184 EOF
185     cat << EOF
186 - path: /var/lib/cloud/scripts/per-boot/set_provider_network.sh
187   owner: root:root
188   permissions: '0777'
189   content: |
190     #!/usr/bin/env bash
191     set -xe
192     route add default gw $PROVIDER_NETWORK_GATEWAY
193     sed -i -e 's/^#DNS=.*/DNS=$PROVIDER_NETWORK_DNS/g' /etc/systemd/resolved.conf
194     systemctl daemon-reload
195     systemctl restart systemd-resolved
196 EOF
197 }
198
199 function apply_userdata_credential {
200     name="$1"
201     cat <<EOF > ./$name-user-data-credential.yaml
202 apiVersion: v1
203 data:
204   userData: $(base64 -w 0 $name-userdata.yaml)
205 kind: Secret
206 metadata:
207   name: $name-user-data
208   namespace: metal3
209 type: Opaque
210 EOF
211     kubectl apply -n metal3 -f $name-user-data-credential.yaml
212 }
213
214 function make_bm_hosts {
215     while IFS=',' read -r name ipmi_username ipmi_password ipmi_address os_username os_password os_image_name; do
216         create_userdata $name $os_username $os_password
217         apply_userdata_credential $name
218
219         go run $GOPATH/src/github.com/metal3-io/baremetal-operator/cmd/make-bm-worker/main.go \
220            -address "ipmi://$ipmi_address" \
221            -password "$ipmi_password" \
222            -user "$ipmi_username" \
223            "$name" > $name-bm-node.yaml
224
225         printf "  image:" >> $name-bm-node.yaml
226         printf "\n    url: ""%s" "$IMAGE_URL" >> $name-bm-node.yaml
227         printf "\n    checksum: ""%s" "$IMAGE_CHECKSUM" >> $name-bm-node.yaml
228         printf "\n  userData:" >> $name-bm-node.yaml
229         printf "\n    name: ""%s" "$name""-user-data" >> $name-bm-node.yaml
230         printf "\n    namespace: metal3" >> $name-bm-node.yaml
231         printf "\n  rootDeviceHints:" >> $name-bm-node.yaml
232         printf "\n    minSizeGigabytes: 48\n" >> $name-bm-node.yaml
233         kubectl apply -f $name-bm-node.yaml -n metal3
234     done
235 }
236
237 function configure_nodes {
238     if [ ! -d $IRONIC_DATA_DIR ]; then
239         mkdir -p $IRONIC_DATA_DIR
240     fi
241
242     #make sure nodes.json file in /opt/ironic/ are configured
243     if [ ! -f $IRONIC_DATA_DIR/nodes.json ]; then
244         cp $PWD/nodes.json.sample $IRONIC_DATA_DIR/nodes.json
245     fi
246 }
247
248 function remove_bm_hosts {
249     while IFS=',' read -r name ipmi_username ipmi_password ipmi_address os_username os_password os_image_name; do
250         deprovision_compute_node $name
251     done
252 }
253
254 function cleanup {
255     while IFS=',' read -r name ipmi_username ipmi_password ipmi_address os_username os_password os_image_name; do
256         kubectl delete --ignore-not-found=true bmh $name -n metal3
257         kubectl delete --ignore-not-found=true secrets $name-bmc-secret -n metal3
258         kubectl delete --ignore-not-found=true secrets $name-user-data -n metal3
259         if [ -f $name-bm-node.yaml ]; then
260             rm -rf $name-bm-node.yaml
261         fi
262
263         if [ -f $name-user-data-credential.yaml ]; then
264             rm -rf $name-user-data-credential.yaml
265         fi
266
267         if [ -f $name-userdata.yaml ]; then
268             rm -rf $name-userdata.yaml
269         fi
270     done
271 }
272
273 function clean_all {
274     list_nodes | cleanup
275     if [ -f $IRONIC_DATA_DIR/nodes.json ]; then
276         rm -rf $IRONIC_DATA_DIR/nodes.json
277     fi
278 }
279
280 function apply_bm_hosts {
281     list_nodes | make_bm_hosts
282 }
283
284 function deprovision_all_hosts {
285     list_nodes | remove_bm_hosts
286 }
287
288 if [ "$1" == "launch" ]; then
289     clone_repos
290     launch_baremetal_operator
291     exit 0
292 fi
293
294 if [ "$1" == "deprovision" ]; then
295     configure_nodes
296     deprovision_all_hosts
297     exit 0
298 fi
299
300 if [ "$1" == "provision" ]; then
301     configure_nodes
302     apply_bm_hosts
303     exit 0
304 fi
305
306 if [ "$1" == "clean" ]; then
307     configure_nodes
308     clean_all
309     exit 0
310 fi
311
312 if [ "$1" == "remove" ]; then
313     remove_baremetal_operator
314     exit 0
315 fi
316
317 echo "Usage: metal3.sh"
318 echo "launch      - Launch the metal3 operator"
319 echo "provision   - provision baremetal node as specified in common.sh"
320 echo "deprovision - deprovision baremetal node as specified in common.sh"
321 echo "clean       - clean all the bmh resources"
322 echo "remove      - remove baremetal operator"
323 exit 1
324
325 #Following code is tested for the offline mode
326 #Will be intergrated for the offline mode for ICNi v.0.1.0 beta
327 #create_ssh_key
328 #create_userdata
329 #set_compute_key
330 #set_compute_ssh_config